<%
'
' PDF Print Job Trigger Using Webpage.  Author Joe McCormack.
'
Dim ptList : ptList = ""								' Dynamically Generated List Of Printers
Dim ptServer : ptServer = "10.100.10.10"						' IP Address of Print Server
Dim papp_Path : pApp_Path = "C:\Program Files\Adobe\Acrobat 7.0\Reader\AcroRd32.exe"	' Adobe Reader Location On Server
Dim pfile_Path : pfile_Path = "F:\docs\pdf\report.pdf"					' Document To Print On Server
Dim pprimary_IP : pprimary_IP = "200.100.80.100"					' IP Address of Primary Printer
Dim pprimary_Name : pprimary_Name = "MAINPNT"						' Name of Primary Printer
Dim psecondary_IP : psecondary_IP = "200.100.80.104"					' IP Address of Secondary Printer
Dim pSecondary_Name : pSecondary_Name = "SECPNT"					' Name of Secondary Printer

Function docPrint(ptServer, pApp_Path, pfile_Path, pprimary_IP, pprimary_Name, psecondary_IP, pSecondary_Name)
	Dim strResults, ptFlag, finalStat
	Set objShell = CreateObject("WScript.Shell")
	strResults = "" : ptFlag = 0 : finalStat = "Fail"
	Set objExecObject = objShell.Exec("net view \\" & ptServer)
	Do
		strResults = Replace(objExecObject.StdOut.ReadLine(), vbcrlf, "")
		if Len(strResults) > 0 AND InStr(strResults, " Print ") > 0 Then
			if ptFlag = 0 Then
				ptList = RTrim(Split(strResults, " Print ")(0)) : ptFlag = 1
			Else
				ptList = ptList & "," & RTrim(Split(strResults, " Print ")(0))
			End if
		End if
	Loop Until objExecObject.Status <> 0
	Set objShell = Nothing : Set objExecObject = Nothing
	if ptFlag = 1 Then
		ptFlag = 0
		if packetRead(pprimary_IP) = "Pass" Then
			pGenPrint pApp_Path, pfile_Path, ptServer, pprimary_Name
			ptFlag = 1
		Else
			if packetRead(psecondary_IP) = "Pass" Then
				pGenPrint pApp_Path, pfile_Path, ptServer, pSecondary_Name
				ptFlag = 1
			End if
		End if
	End if
	if ptFlag = 1 Then : finalStat = "Pass" : End if
docPrint = finalStat
End Function
Function pGenPrint(pApp, pPath, pServer, pName)
	Dim strResults : strResults = ""
	printerUsed = pName
	Set objShell = CreateObject("WScript.Shell")
	Set objExecObject = objShell.Exec ("""" & pApp & """ /t " & pPath & " ""\\" & pServer & "\" & pName & """")
	Do
		strResults = Replace(objExecObject2.StdOut.ReadLine(), vbcrlf, "")
	Loop Until objExecObject.Status <> 0
	Set objExecObject = Nothing : Set objShell = Nothing
End Function
Function packetRead(pIP)
	Dim strResults, ptFlag, Results, psSent, psReceived, psLost
	strResults = "" : Results = "Fail" : ptFlag = 0 : psSent = 0 : psReceived = 0 : psLost = 0
	Set objShell = CreateObject("WScript.Shell")
	Set objExecObject = objShell.Exec("ping " & pIP)
	Do
		strResults = Replace(Replace(objExecObject.StdOut.ReadLine(), vbcrlf, ""), " ", "")
		if Len(strResults) > 0 AND InStr(strResults, "Packets:") > 0 Then
			strResults = Replace(strResults, "Packets:", "")
			psSent = Split(Split(strResults, ",")(0), "=")(1)
			psReceived = Split(Split(strResults, ",")(1), "=")(1)
			psLost = Split(Split(Split(strResults, ",")(2), "=")(1), "(")(0)
		End if
	Loop Until objExecObject.Status <> 0
	Set objShell = Nothing : Set objExecObject = Nothing
	if psSent = psReceived AND psLost = 0 Then
		Results = "Pass"
	End if
packetRead = Results
End Function
Function pStatusDetect(pName)
	Dim Results : Results = "Printer Not Found"
	Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	Set objWMIPrinters =  objWMIService.ExecQuery("Select * from Win32_Printer")
	For Each objPrinter in objWMIPrinters
		Select Case objPrinter.PrinterStatus
			Case 1
				strPrinterStatus = "Other"
			Case 2
				strPrinterStatus = "Unknown"
			Case 3
				strPrinterStatus = "Idle"
			Case 4
				strPrinterStatus = "Printing"
			Case 5
				strPrinterStatus = "Warmup"
		End Select
		if LCase(objPrinter.Name) = LCase(pName) Then
			Results = strPrinterStatus
		End if
	Next
pStatusDetect = Results
End Function

' Conduct A Print
response.write docPrint ptServer, pApp_Path, pfile_Path, pprimary_IP, pprimary_Name, psecondary_IP, pSecondary_Name
%>
